import random

from edmond.plugin import Plugin


P_TIME = [
    "ce matin", "hier soir", "aujourd'hui", "tout à l'heure", "au réveil", "",
]
P_ACTION = [
    "j'ai aperçu", "j'ai caressé", "j'ai nadenade", "j'ai passé du temps avec",
    "je me suis arrêté vers", "je me suis promené avec", "j'ai salué",
    "j'ai approché", "j'ai suivi", "je me suis assis devant", "j'ai regardé",
    "j'ai parlé avec", "j'ai écouté", "j'ai tokotoko", "j'ai nourri",
    "j'ai mofu",
]
P_SUBJ = [
    "le chat", "le chat calico", "le chat noir", "le chaton", "le chat tigré",
    "le chat blanc", "le chat tigré", "le chat gris", "le chat avec le cœur",
    "le chat errant", "le vieux chat", "le gros chat", "le petit chat",
    "le chat doux", "le beau chat", "le chat tuxedo", "le chat mignon",
    "le chat fuwa fuwa",
]
P_PLACE = [
    "en ville", "au port de pêche", "sur l'île", "sous l'arbre", "au parc",
    "au monument de pierre", "sur la plage", "sur le chemin", "dans l'herbe",
    "devant l'école", "dans la petite cour", "sur la route de montagne",
    "qui miaulait", "qui dormait", "qui était devant la boutique",
    "qui voulait manger", "qui demandait le nadenade", "sous l'abri",
    "sur le quai", "à l'autel", "à la station", "dans la ruelle",
]
P_COORD = [
    "et", "et donc", "et puis", "après quoi",
]
P_ACTION2 = [
    "il a miaulé", "il s'est endormi", "il m'a remercié",
    "il est resté avec moi", "il m'a parlé", "il a blep",
    "il m'a suivi", "il a reclamé un nadenade", "il est monté sur le toît",
    "il s'est roulé en boule", "il était mignon", "il était noshinoshi",
    "il a gorogoro", "il s'est roulé sur le dos", "il s'est caché",
    "il est venu", "il est monté sur mes genoux", "il m'a soigné",
    "il m'a kurukuru",
]


def get_title():
    return " ".join((
        random.choice(P_TIME),
        random.choice(P_ACTION),
        random.choice(P_SUBJ),
        random.choice(P_PLACE),
        random.choice(P_COORD),
        random.choice(P_ACTION2),
    )).strip().capitalize()


class DoupslandPlugin(Plugin):

    REQUIRED_CONFIGS = ["commands"]

    def __init__(self, bot):
        super().__init__(bot)

    def on_pubmsg(self, event):
        if not self.should_handle_command(event.arguments[0]):
            return False

        reply = get_title()
        self.bot.say(event.target, reply)
        return True
